library benchpress.src.reporter.multi_reporter;

import "package:angular2/src/core/di.dart"
    show bind, provide, Provider, Injector, OpaqueToken;
import "package:angular2/src/facade/async.dart" show Future, PromiseWrapper;
import "../measure_values.dart" show MeasureValues;
import "../reporter.dart" show Reporter;

class MultiReporter extends Reporter {
  static List<Provider> createBindings(List<dynamic> childTokens) {
    return [
      bind(_CHILDREN).toFactory(
          (Injector injector) =>
              childTokens.map((token) => injector.get(token)).toList(),
          [Injector]),
      bind(MultiReporter)
          .toFactory((children) => new MultiReporter(children), [_CHILDREN])
    ];
  }

  List<Reporter> _reporters;
  MultiReporter(reporters) : super() {
    /* super call moved to initializer */;
    this._reporters = reporters;
  }
  Future<List<dynamic>> reportMeasureValues(MeasureValues values) {
    return PromiseWrapper.all(this
        ._reporters
        .map((reporter) => reporter.reportMeasureValues(values))
        .toList());
  }

  Future<List<dynamic>> reportSample(
      List<MeasureValues> completeSample, List<MeasureValues> validSample) {
    return PromiseWrapper.all(this
        ._reporters
        .map((reporter) => reporter.reportSample(completeSample, validSample))
        .toList());
  }
}

var _CHILDREN = new OpaqueToken("MultiReporter.children");
