library benchpress.src.validator.size_validator;

import "package:angular2/src/facade/collection.dart" show ListWrapper;
import "package:angular2/src/core/di.dart"
    show bind, provide, Provider, OpaqueToken;
import "../validator.dart" show Validator;
import "../measure_values.dart" show MeasureValues;

/**
 * A validator that waits for the sample to have a certain size.
 */
class SizeValidator extends Validator {
  // TODO(tbosch): use static values when our transpiler supports them
  static List<Provider> get BINDINGS {
    return _PROVIDERS;
  }

  // TODO(tbosch): use static values when our transpiler supports them
  static get SAMPLE_SIZE {
    return _SAMPLE_SIZE;
  }

  num _sampleSize;
  SizeValidator(size) : super() {
    /* super call moved to initializer */;
    this._sampleSize = size;
  }
  Map<String, dynamic> describe() {
    return {"sampleSize": this._sampleSize};
  }

  List<MeasureValues> validate(List<MeasureValues> completeSample) {
    if (completeSample.length >= this._sampleSize) {
      return ListWrapper.slice(completeSample,
          completeSample.length - this._sampleSize, completeSample.length);
    } else {
      return null;
    }
  }
}

var _SAMPLE_SIZE = new OpaqueToken("SizeValidator.sampleSize");
var _PROVIDERS = [
  bind(SizeValidator)
      .toFactory((size) => new SizeValidator(size), [_SAMPLE_SIZE]),
  provide(_SAMPLE_SIZE, useValue: 10)
];
